#include <windows.h>
#include "ResPQUnicode.h"

TCHAR tcStr[1024];
TCHAR tcUni[1024*4];

void DispUnicode(HWND hChars, HWND hUnis, bool WikiMode)
{
	TCHAR *pStr, *pUni;

	GetWindowText(hChars, tcStr, sizeof(tcStr));

	for (pStr = tcStr, pUni = tcUni; *pStr; pStr++ )
	{
		TCHAR wc = *pStr;
		if (wc == 0xd || wc == 0xa)
		{
			if (pStr[1] == 0xa)
				pStr++;
		}
		else
		{
			if (WikiMode)
				pUni += wsprintf(pUni, TEXT("|%c|%d|ϖ|\r\n"), wc, wc);
			else
				pUni += wsprintf(pUni, TEXT("%c\t%d\t0x%04x\r\n"), wc, wc, wc);
		}
	}

	*pUni = 0;
	SetWindowText(hUnis, tcUni);
}

WORD ToWORD(TCHAR *pStr)
{
	TCHAR *p = pStr, c;
	int ret, mode;

	if (p[0] == '0' && p[1] == 'x')
	{
		mode = 16;  p+=2;
	}
	else
	{
		mode = 10;
	}

	ret = 0;
	if (mode == 16)
	{
		int len = 0;
		while (*p && len<4)
		{
			c = *p;
			if ( (c>='a') && (c<='f') ) c = c - 'a' + 10;
			else if ( (c>='A') && (c<='F') ) c = c - 'A' + 10;
			else if ( (c>='0') && (c<='9') ) c = c - '0';
			else break;

			ret = (ret<<4) | c;
			len++;
			p++;
		}
	}
	else
	{
		while (*p)
		{
			c = *p;
			if ( (c>='0') && (c<='9') ) c = c - '0';
			else break;

			ret = (ret*10) + c;
			p++;
		}
	}

	return (WORD)ret;
}

void DispChar(HWND hUni, HWND hChar)
{
	TCHAR wc;

	GetWindowText(hUni, tcUni, sizeof(tcUni));

	wc = ToWORD(tcUni);

	tcStr[0]=wc;
	tcStr[1]=0;
	SetWindowText(hChar, tcStr);
}

BOOL WINAPI PQUniDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
		case WM_CREATE:
		case WM_INITDIALOG:
			SendDlgItemMessage(hDlg, IDC_CHECK_WIKI, BM_SETCHECK, BST_CHECKED, 0);
			return TRUE;

		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDC_EDIT_CHARS:
					if (HIWORD(wParam) == EN_CHANGE)
					{
						bool Checked = SendDlgItemMessage(hDlg, IDC_CHECK_WIKI, BM_GETCHECK, 0, 0) == BST_CHECKED;
						DispUnicode((HWND)lParam, GetDlgItem(hDlg, IDC_EDIT_UCS), Checked);
						return TRUE;
					}
					break;

				case IDC_EDIT_UNI:
					if (HIWORD(wParam) == EN_CHANGE)
					{
						DispChar((HWND)lParam, GetDlgItem(hDlg, IDC_EDIT_CHAR));
						return TRUE;
					}
					break;

				case IDC_CHECK_WIKI:
					if (HIWORD(wParam) == BN_CLICKED)
					{
						bool Checked = SendDlgItemMessage(hDlg, IDC_CHECK_WIKI, BM_GETCHECK, 0, 0) == BST_CHECKED;
						DispUnicode(GetDlgItem(hDlg, IDC_EDIT_CHARS), GetDlgItem(hDlg, IDC_EDIT_UCS), Checked);
						return TRUE;
					}
					break;

				case IDCANCEL:
					EndDialog(hDlg, FALSE);
					return TRUE;
			}
			break;
	}
	return FALSE;//DefDlgProc(hDlg, uMsg, wParam, lParam);
}

BOOL InitApp(HINSTANCE hInst)
{
	WNDCLASS wc;

	if (GetClassInfo(hInst, TEXT("#32770"), &wc)==0)
		return FALSE;

	wc.cbWndExtra = DLGWINDOWEXTRA;
	wc.lpszClassName = TEXT(PQDLGCLASS);
	wc.hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_MAIN));

	if (RegisterClass(&wc)==0)
		return FALSE;

	return TRUE;
}

int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpszCmd, int nCmdShow)
{
	if (InitApp(hInst)==FALSE)
		return 0;

	DialogBox(hInst, MAKEINTRESOURCE(IDD_PQUNI), NULL, PQUniDlgProc);
	return 0;
}

void WinMainCRTStartup()
{
	ExitProcess(WinMain(GetModuleHandle(NULL), NULL, "", 0));
}
